package com.lwitz.entities;

import org.mini2Dx.core.engine.geom.CollisionPoint;
import org.mini2Dx.core.game.GameContainer;
import org.mini2Dx.core.graphics.Graphics;

public class Entity {
	protected CollisionPoint pos;
	protected EntityState state;
	
	public Entity(CollisionPoint pos, EntityState state){
		if(pos == null)
			pos = new CollisionPoint();
		this.pos = pos;
		this.state = state;
	}
	
	public void update(GameContainer gc, float delta){
		if(state != null){
			EntityState returned = state.update(gc, pos, delta);
			if(returned != null){
				this.state = returned;
			}
		}
	}
	
	public void interpolate(GameContainer gc, float alpha){
		if(state != null)
			state.interpolate(gc, pos, alpha);
	}
	
	public void render(GameContainer gc, Graphics g){
		if(state != null)
			state.render(gc, pos, g);
	}
}
