package com.lwitz.entities;

import org.mini2Dx.core.engine.geom.CollisionPoint;
import org.mini2Dx.core.game.GameContainer;
import org.mini2Dx.core.graphics.Graphics;
import org.mini2Dx.core.graphics.Sprite;

import com.badlogic.gdx.Gdx;
import com.badlogic.gdx.Input.Keys;
import com.badlogic.gdx.graphics.Texture;

public class WaveState implements EntityState{
	private Texture texture;
	private float angleOffset;
	private float rotationSpeed;
	
	public WaveState(){
		texture = new Texture("wave.png");
		angleOffset = 0;
		rotationSpeed = 3;
	}
	
	@Override
	public void initialize(GameContainer gc, CollisionPoint pos) {
	}

	@Override
	public EntityState update(GameContainer gc, CollisionPoint pos, float delta) {
		if(Gdx.input.isKeyPressed(Keys.RIGHT)){
			angleOffset += rotationSpeed * delta;
			if(angleOffset > 1)
				angleOffset = 1;
		}
		if(Gdx.input.isKeyPressed(Keys.LEFT)){
			angleOffset -= rotationSpeed * delta;
			if(angleOffset < -1)
				angleOffset = -1;
		}
		
		if(Gdx.input.isKeyJustPressed(Keys.SPACE)){
			return new PunchState();
		}
		
		return null;
	}

	@Override
	public void interpolate(GameContainer gc, CollisionPoint pos, float alpha) {
		// TODO Auto-generated method stub
		
	}

	@Override
	public void render(GameContainer gc, CollisionPoint pos, Graphics g) {
		g.setRotation(25 * angleOffset, pos.getX() + texture.getWidth()/2, pos.getY() + texture.getHeight()/2);
		g.drawTexture(texture, pos.getX(), pos.getY());
		g.setRotation(0, pos.getX() + texture.getWidth()/2, pos.getY() + texture.getHeight()/2);
	}

}
