package com.lwitz.entities;

import org.mini2Dx.core.engine.geom.CollisionPoint;
import org.mini2Dx.core.game.GameContainer;
import org.mini2Dx.core.graphics.Graphics;
import org.mini2Dx.core.graphics.Sprite;

import com.badlogic.gdx.graphics.Color;
import com.badlogic.gdx.graphics.Texture;

public class Weight implements Enemy{
	private Sprite sprite;
	private float ySpeed;
	private float tolerance = 10;
	
	public Weight(GameContainer gc){
		ySpeed = 400;
		sprite = new Sprite(new Texture("weight.png"));
		sprite.setPosition((float)(Math.random() * (gc.getWidth() - sprite.getWidth() - sprite.getWidth()/2)), -2 * ySpeed);
	}
	
	@Override
	public boolean update(GameContainer gc, float delta) {
		sprite.setY(sprite.getY() + ySpeed * delta);
		if(sprite.getY() > gc.getHeight())
			return true;
		return false;
	}

	@Override
	public void render(GameContainer gc, Graphics g) {
		if(sprite.getY() > 0){
			g.drawSprite(sprite);
			g.drawRect(sprite.getX() + tolerance, sprite.getY() + 3*tolerance, sprite.getWidth() - 2*tolerance, sprite.getHeight() - 4*tolerance);
		} else {
			Color old = g.getColor();
			g.setColor(old.cpy().add(sprite.getY() / (3 * ySpeed), sprite.getY() / (3 * ySpeed), sprite.getY() / (3 * ySpeed), 0));
			g.fillCircle(sprite.getX() + sprite.getWidth(), sprite.getHeight() / 2, sprite.getWidth() / 4);
			g.setColor(old);
		}
	}

	@Override
	public boolean checkCollision(CollisionPoint pos, int width, int height) {
		if(sprite.getY() + sprite.getHeight() - tolerance > pos.y && sprite.getY() + 3 * tolerance < pos.y + height){
			if(sprite.getX() + sprite.getWidth() - tolerance > pos.x && sprite.getX() + tolerance < pos.x + width){
				return true;
			}
		}
		return false;
	}

}
